/* A Bison parser, made by GNU Bison 2.4.2.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2006, 2009-2010 Free Software
   Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         asmshader_parse
#define yylex           asmshader_lex
#define yyerror         asmshader_error
#define yylval          asmshader_lval
#define yychar          asmshader_char
#define yydebug         asmshader_debug
#define yynerrs         asmshader_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 22 "asmshader.y"

#include "config.h"
#include "wine/port.h"
#include "wine/debug.h"

#include "d3dx9_36_private.h"

#include <stdio.h>

WINE_DEFAULT_DEBUG_CHANNEL(asmshader);

struct asm_parser asm_ctx;

/* Needed lexer functions declarations */
void asmshader_error(const char *s);
int asmshader_lex(void);

void set_rel_reg(struct shader_reg *reg, struct rel_reg *rel) {
    /* We can have an additional offset without true relative addressing
     * ex. c2[ 4 ] */
    reg->regnum += rel->additional_offset;
    if(!rel->has_rel_reg) {
        reg->rel_reg = NULL;
    } else {
        reg->rel_reg = asm_alloc(sizeof(*reg->rel_reg));
        if(!reg->rel_reg) {
            return;
        }
        reg->rel_reg->type = rel->type;
        reg->rel_reg->swizzle = rel->swizzle;
        reg->rel_reg->regnum = rel->rel_regnum;
    }
}



/* Line 189 of yacc.c  */
#line 117 "asmshader.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     INSTR_ADD = 258,
     INSTR_NOP = 259,
     INSTR_MOV = 260,
     INSTR_SUB = 261,
     INSTR_MAD = 262,
     INSTR_MUL = 263,
     INSTR_RCP = 264,
     INSTR_RSQ = 265,
     INSTR_DP3 = 266,
     INSTR_DP4 = 267,
     INSTR_MIN = 268,
     INSTR_MAX = 269,
     INSTR_SLT = 270,
     INSTR_SGE = 271,
     INSTR_ABS = 272,
     INSTR_EXP = 273,
     INSTR_LOG = 274,
     INSTR_EXPP = 275,
     INSTR_LOGP = 276,
     INSTR_DST = 277,
     INSTR_LRP = 278,
     INSTR_FRC = 279,
     INSTR_POW = 280,
     INSTR_CRS = 281,
     INSTR_SGN = 282,
     INSTR_NRM = 283,
     INSTR_SINCOS = 284,
     INSTR_M4x4 = 285,
     INSTR_M4x3 = 286,
     INSTR_M3x4 = 287,
     INSTR_M3x3 = 288,
     INSTR_M3x2 = 289,
     INSTR_DCL = 290,
     INSTR_DEF = 291,
     INSTR_DEFB = 292,
     INSTR_DEFI = 293,
     INSTR_REP = 294,
     INSTR_ENDREP = 295,
     INSTR_IF = 296,
     INSTR_ELSE = 297,
     INSTR_ENDIF = 298,
     INSTR_BREAK = 299,
     INSTR_BREAKP = 300,
     INSTR_CALL = 301,
     INSTR_CALLNZ = 302,
     INSTR_LOOP = 303,
     INSTR_RET = 304,
     INSTR_ENDLOOP = 305,
     INSTR_LABEL = 306,
     INSTR_SETP = 307,
     INSTR_TEXLDL = 308,
     INSTR_LIT = 309,
     INSTR_MOVA = 310,
     INSTR_CMP = 311,
     INSTR_DP2ADD = 312,
     INSTR_TEXKILL = 313,
     INSTR_TEXLD = 314,
     INSTR_DSX = 315,
     INSTR_DSY = 316,
     INSTR_TEXLDP = 317,
     INSTR_TEXLDB = 318,
     INSTR_TEXLDD = 319,
     REG_TEMP = 320,
     REG_OUTPUT = 321,
     REG_INPUT = 322,
     REG_CONSTFLOAT = 323,
     REG_CONSTINT = 324,
     REG_CONSTBOOL = 325,
     REG_TEXTURE = 326,
     REG_SAMPLER = 327,
     REG_TEXCRDOUT = 328,
     REG_OPOS = 329,
     REG_OFOG = 330,
     REG_OPTS = 331,
     REG_VERTEXCOLOR = 332,
     REG_FRAGCOLOR = 333,
     REG_FRAGDEPTH = 334,
     REG_VPOS = 335,
     REG_VFACE = 336,
     REG_ADDRESS = 337,
     REG_LOOP = 338,
     REG_PREDICATE = 339,
     REG_LABEL = 340,
     VER_VS10 = 341,
     VER_VS11 = 342,
     VER_VS20 = 343,
     VER_VS2X = 344,
     VER_VS30 = 345,
     VER_PS10 = 346,
     VER_PS11 = 347,
     VER_PS12 = 348,
     VER_PS13 = 349,
     VER_PS14 = 350,
     VER_PS20 = 351,
     VER_PS2X = 352,
     VER_PS30 = 353,
     MOD_SAT = 354,
     MOD_PP = 355,
     MOD_CENTROID = 356,
     COMP_GT = 357,
     COMP_LT = 358,
     COMP_GE = 359,
     COMP_LE = 360,
     COMP_EQ = 361,
     COMP_NE = 362,
     SMOD_ABS = 363,
     SMOD_NOT = 364,
     SAMPTYPE_1D = 365,
     SAMPTYPE_2D = 366,
     SAMPTYPE_CUBE = 367,
     SAMPTYPE_VOLUME = 368,
     USAGE_POSITION = 369,
     USAGE_BLENDWEIGHT = 370,
     USAGE_BLENDINDICES = 371,
     USAGE_NORMAL = 372,
     USAGE_PSIZE = 373,
     USAGE_TEXCOORD = 374,
     USAGE_TANGENT = 375,
     USAGE_BINORMAL = 376,
     USAGE_TESSFACTOR = 377,
     USAGE_POSITIONT = 378,
     USAGE_COLOR = 379,
     USAGE_FOG = 380,
     USAGE_DEPTH = 381,
     USAGE_SAMPLE = 382,
     COMPONENT = 383,
     IMMVAL = 384,
     IMMBOOL = 385
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 58 "asmshader.y"

    struct {
        float           val;
        BOOL            integer;
    } immval;
    BOOL                immbool;
    unsigned int        regnum;
    struct shader_reg   reg;
    DWORD               srcmod;
    DWORD               writemask;
    struct {
        DWORD           writemask;
        DWORD           idx;
        DWORD           last;
    } wm_components;
    DWORD               swizzle;
    struct {
        DWORD           swizzle;
        DWORD           idx;
    } sw_components;
    DWORD               component;
    struct {
        DWORD           mod;
        DWORD           shift;
    } modshift;
    BWRITER_COMPARISON_TYPE comptype;
    struct {
        DWORD           dclusage;
        unsigned int    regnum;
    } declaration;
    BWRITERSAMPLER_TEXTURE_TYPE samplertype;
    struct rel_reg      rel_reg;
    struct src_regs     sregs;



/* Line 214 of yacc.c  */
#line 320 "asmshader.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 332 "asmshader.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  16
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   556

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  139
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  26
/* YYNRULES -- Number of rules.  */
#define YYNRULES  192
/* YYNRULES -- Number of states.  */
#define YYNSTATES  432

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   385

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     137,   138,     2,   136,   131,   133,   132,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   134,     2,   135,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     8,    10,    12,    14,    16,    18,
      20,    22,    24,    26,    28,    30,    32,    33,    36,    38,
      41,    47,    49,    55,    61,    67,    73,    79,    85,    91,
      97,   103,   109,   115,   121,   127,   133,   139,   145,   151,
     157,   163,   169,   175,   181,   187,   193,   199,   205,   211,
     217,   223,   229,   233,   238,   243,   249,   253,   258,   263,
     267,   272,   277,   288,   299,   304,   307,   309,   312,   316,
     318,   320,   322,   326,   329,   332,   335,   338,   340,   342,
     345,   351,   357,   363,   369,   375,   381,   384,   390,   396,
     402,   408,   414,   420,   423,   426,   428,   430,   432,   434,
     436,   438,   440,   442,   444,   446,   448,   450,   452,   454,
     456,   458,   460,   462,   464,   466,   469,   471,   474,   475,
     478,   480,   483,   484,   487,   489,   491,   493,   495,   499,
     503,   508,   513,   519,   523,   524,   528,   533,   540,   547,
     556,   558,   562,   564,   566,   568,   570,   572,   574,   576,
     578,   580,   582,   584,   586,   588,   590,   592,   594,   596,
     598,   600,   602,   604,   606,   608,   610,   612,   614,   616,
     618,   620,   622,   624,   626,   628,   630,   632,   634,   636,
     638,   640,   642,   644,   646,   648,   650,   652,   654,   656,
     658,   660,   665
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     140,     0,    -1,   141,   142,    -1,    86,    -1,    87,    -1,
      88,    -1,    89,    -1,    90,    -1,    91,    -1,    92,    -1,
      93,    -1,    94,    -1,    95,    -1,    96,    -1,    97,    -1,
      98,    -1,    -1,   142,   143,    -1,   144,    -1,   164,   144,
      -1,     3,   151,   145,   131,   153,    -1,     4,    -1,     5,
     151,   145,   131,   153,    -1,     6,   151,   145,   131,   153,
      -1,     7,   151,   145,   131,   153,    -1,     8,   151,   145,
     131,   153,    -1,     9,   151,   145,   131,   153,    -1,    10,
     151,   145,   131,   153,    -1,    11,   151,   145,   131,   153,
      -1,    12,   151,   145,   131,   153,    -1,    13,   151,   145,
     131,   153,    -1,    14,   151,   145,   131,   153,    -1,    15,
     151,   145,   131,   153,    -1,    16,   151,   145,   131,   153,
      -1,    17,   151,   145,   131,   153,    -1,    18,   151,   145,
     131,   153,    -1,    19,   151,   145,   131,   153,    -1,    21,
     151,   145,   131,   153,    -1,    20,   151,   145,   131,   153,
      -1,    22,   151,   145,   131,   153,    -1,    23,   151,   145,
     131,   153,    -1,    24,   151,   145,   131,   153,    -1,    25,
     151,   145,   131,   153,    -1,    26,   151,   145,   131,   153,
      -1,    27,   151,   145,   131,   153,    -1,    28,   151,   145,
     131,   153,    -1,    29,   151,   145,   131,   153,    -1,    30,
     151,   145,   131,   153,    -1,    31,   151,   145,   131,   153,
      -1,    32,   151,   145,   131,   153,    -1,    33,   151,   145,
     131,   153,    -1,    34,   151,   145,   131,   153,    -1,    35,
     161,    66,    -1,    35,   161,    66,   147,    -1,    35,   161,
     151,   162,    -1,    35,   161,   151,   162,   147,    -1,    35,
     151,   162,    -1,    35,   151,   162,   147,    -1,    35,   163,
     151,    72,    -1,    35,   151,    72,    -1,    35,   163,   151,
     162,    -1,    35,   163,   151,    66,    -1,    36,    68,   131,
     129,   131,   129,   131,   129,   131,   129,    -1,    38,    69,
     131,   129,   131,   129,   131,   129,   131,   129,    -1,    37,
      70,   131,   130,    -1,    39,   153,    -1,    40,    -1,    41,
     153,    -1,    41,   160,   153,    -1,    42,    -1,    43,    -1,
      44,    -1,    44,   160,   153,    -1,    45,   153,    -1,    46,
     153,    -1,    47,   153,    -1,    48,   153,    -1,    49,    -1,
      50,    -1,    51,   153,    -1,    52,   160,   145,   131,   153,
      -1,    53,   151,   145,   131,   153,    -1,    54,   151,   145,
     131,   153,    -1,    55,   151,   145,   131,   153,    -1,    56,
     151,   145,   131,   153,    -1,    57,   151,   145,   131,   153,
      -1,    58,   145,    -1,    59,   151,   145,   131,   153,    -1,
      62,   151,   145,   131,   153,    -1,    63,   151,   145,   131,
     153,    -1,    60,   151,   145,   131,   153,    -1,    61,   151,
     145,   131,   153,    -1,    64,   151,   145,   131,   153,    -1,
     146,   155,    -1,   146,   147,    -1,    65,    -1,    66,    -1,
      67,    -1,    68,    -1,    69,    -1,    70,    -1,    71,    -1,
      73,    -1,    72,    -1,    74,    -1,    76,    -1,    75,    -1,
      77,    -1,    78,    -1,    79,    -1,    84,    -1,    80,    -1,
      81,    -1,    82,    -1,    83,    -1,   132,   148,    -1,   128,
      -1,   148,   128,    -1,    -1,   132,   150,    -1,   128,    -1,
     150,   128,    -1,    -1,   151,   152,    -1,    99,    -1,   100,
      -1,   101,    -1,   154,    -1,   153,   131,   154,    -1,   159,
     155,   149,    -1,   159,   155,   157,   149,    -1,   133,   159,
     155,   149,    -1,   133,   159,   155,   157,   149,    -1,   109,
     159,   149,    -1,    -1,   134,   156,   135,    -1,   134,   158,
     149,   135,    -1,   134,   156,   136,   158,   149,   135,    -1,
     134,   158,   149,   136,   156,   135,    -1,   134,   156,   136,
     158,   149,   136,   156,   135,    -1,   129,    -1,   156,   136,
     129,    -1,   108,    -1,    82,    -1,    83,    -1,    65,    -1,
      66,    -1,    67,    -1,    68,    -1,    69,    -1,    70,    -1,
      71,    -1,    73,    -1,    72,    -1,    74,    -1,    75,    -1,
      77,    -1,    78,    -1,    79,    -1,    84,    -1,    80,    -1,
      81,    -1,    82,    -1,    83,    -1,    85,    -1,   102,    -1,
     103,    -1,   104,    -1,   105,    -1,   106,    -1,   107,    -1,
     114,    -1,   115,    -1,   116,    -1,   117,    -1,   118,    -1,
     119,    -1,   120,    -1,   121,    -1,   122,    -1,   123,    -1,
     124,    -1,   125,    -1,   126,    -1,   127,    -1,    67,    -1,
      71,    -1,   110,    -1,   111,    -1,   112,    -1,   113,    -1,
     137,    84,   149,   138,    -1,   137,   109,    84,   149,   138,
      -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   267,   267,   272,   277,   282,   287,   292,   297,   303,
     309,   315,   321,   327,   332,   337,   343,   344,   349,   353,
     359,   364,   369,   374,   379,   384,   389,   394,   399,   404,
     409,   414,   419,   424,   429,   434,   439,   444,   449,   454,
     459,   464,   469,   474,   479,   484,   489,   494,   499,   504,
     509,   514,   519,   531,   543,   560,   577,   594,   611,   621,
     636,   643,   650,   654,   658,   662,   667,   672,   677,   682,
     687,   692,   697,   702,   707,   712,   717,   722,   727,   732,
     737,   742,   747,   752,   757,   762,   767,   772,   783,   788,
     793,   798,   803,   809,   817,   826,   830,   834,   838,   844,
     850,   856,   860,   864,   870,   874,   878,   882,   886,   890,
     894,   898,   904,   910,   915,   922,   937,   943,   959,   963,
     985,   990,  1004,  1008,  1021,  1026,  1031,  1037,  1042,  1053,
    1061,  1069,  1077,  1089,  1099,  1103,  1108,  1116,  1124,  1132,
    1141,  1150,  1160,  1165,  1169,  1174,  1178,  1184,  1188,  1192,
    1196,  1200,  1204,  1210,  1214,  1220,  1226,  1232,  1238,  1244,
    1248,  1252,  1256,  1260,  1264,  1269,  1270,  1271,  1272,  1273,
    1274,  1276,  1282,  1288,  1294,  1300,  1306,  1312,  1318,  1324,
    1330,  1336,  1342,  1348,  1354,  1361,  1365,  1370,  1374,  1378,
    1382,  1387,  1395
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "INSTR_ADD", "INSTR_NOP", "INSTR_MOV",
  "INSTR_SUB", "INSTR_MAD", "INSTR_MUL", "INSTR_RCP", "INSTR_RSQ",
  "INSTR_DP3", "INSTR_DP4", "INSTR_MIN", "INSTR_MAX", "INSTR_SLT",
  "INSTR_SGE", "INSTR_ABS", "INSTR_EXP", "INSTR_LOG", "INSTR_EXPP",
  "INSTR_LOGP", "INSTR_DST", "INSTR_LRP", "INSTR_FRC", "INSTR_POW",
  "INSTR_CRS", "INSTR_SGN", "INSTR_NRM", "INSTR_SINCOS", "INSTR_M4x4",
  "INSTR_M4x3", "INSTR_M3x4", "INSTR_M3x3", "INSTR_M3x2", "INSTR_DCL",
  "INSTR_DEF", "INSTR_DEFB", "INSTR_DEFI", "INSTR_REP", "INSTR_ENDREP",
  "INSTR_IF", "INSTR_ELSE", "INSTR_ENDIF", "INSTR_BREAK", "INSTR_BREAKP",
  "INSTR_CALL", "INSTR_CALLNZ", "INSTR_LOOP", "INSTR_RET", "INSTR_ENDLOOP",
  "INSTR_LABEL", "INSTR_SETP", "INSTR_TEXLDL", "INSTR_LIT", "INSTR_MOVA",
  "INSTR_CMP", "INSTR_DP2ADD", "INSTR_TEXKILL", "INSTR_TEXLD", "INSTR_DSX",
  "INSTR_DSY", "INSTR_TEXLDP", "INSTR_TEXLDB", "INSTR_TEXLDD", "REG_TEMP",
  "REG_OUTPUT", "REG_INPUT", "REG_CONSTFLOAT", "REG_CONSTINT",
  "REG_CONSTBOOL", "REG_TEXTURE", "REG_SAMPLER", "REG_TEXCRDOUT",
  "REG_OPOS", "REG_OFOG", "REG_OPTS", "REG_VERTEXCOLOR", "REG_FRAGCOLOR",
  "REG_FRAGDEPTH", "REG_VPOS", "REG_VFACE", "REG_ADDRESS", "REG_LOOP",
  "REG_PREDICATE", "REG_LABEL", "VER_VS10", "VER_VS11", "VER_VS20",
  "VER_VS2X", "VER_VS30", "VER_PS10", "VER_PS11", "VER_PS12", "VER_PS13",
  "VER_PS14", "VER_PS20", "VER_PS2X", "VER_PS30", "MOD_SAT", "MOD_PP",
  "MOD_CENTROID", "COMP_GT", "COMP_LT", "COMP_GE", "COMP_LE", "COMP_EQ",
  "COMP_NE", "SMOD_ABS", "SMOD_NOT", "SAMPTYPE_1D", "SAMPTYPE_2D",
  "SAMPTYPE_CUBE", "SAMPTYPE_VOLUME", "USAGE_POSITION",
  "USAGE_BLENDWEIGHT", "USAGE_BLENDINDICES", "USAGE_NORMAL", "USAGE_PSIZE",
  "USAGE_TEXCOORD", "USAGE_TANGENT", "USAGE_BINORMAL", "USAGE_TESSFACTOR",
  "USAGE_POSITIONT", "USAGE_COLOR", "USAGE_FOG", "USAGE_DEPTH",
  "USAGE_SAMPLE", "COMPONENT", "IMMVAL", "IMMBOOL", "','", "'.'", "'-'",
  "'['", "']'", "'+'", "'('", "')'", "$accept", "shader", "version_marker",
  "instructions", "complexinstr", "instruction", "dreg", "dreg_name",
  "writemask", "wm_components", "swizzle", "sw_components", "omods",
  "omodifier", "sregs", "sreg", "rel_reg", "immsum", "smod", "relreg_name",
  "sreg_name", "comp", "dclusage", "dcl_inputreg", "sampdcl", "predicate", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,    44,    46,    45,    91,    93,    43,    40,    41
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   139,   140,   141,   141,   141,   141,   141,   141,   141,
     141,   141,   141,   141,   141,   141,   142,   142,   143,   143,
     144,   144,   144,   144,   144,   144,   144,   144,   144,   144,
     144,   144,   144,   144,   144,   144,   144,   144,   144,   144,
     144,   144,   144,   144,   144,   144,   144,   144,   144,   144,
     144,   144,   144,   144,   144,   144,   144,   144,   144,   144,
     144,   144,   144,   144,   144,   144,   144,   144,   144,   144,
     144,   144,   144,   144,   144,   144,   144,   144,   144,   144,
     144,   144,   144,   144,   144,   144,   144,   144,   144,   144,
     144,   144,   144,   145,   145,   146,   146,   146,   146,   146,
     146,   146,   146,   146,   146,   146,   146,   146,   146,   146,
     146,   146,   146,   146,   146,   147,   148,   148,   149,   149,
     150,   150,   151,   151,   152,   152,   152,   153,   153,   154,
     154,   154,   154,   154,   155,   155,   155,   155,   155,   155,
     156,   156,   157,   158,   158,   159,   159,   159,   159,   159,
     159,   159,   159,   159,   159,   159,   159,   159,   159,   159,
     159,   159,   159,   159,   159,   160,   160,   160,   160,   160,
     160,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   161,   161,   161,   161,   162,   162,   163,   163,   163,
     163,   164,   164
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     2,     1,     2,
       5,     1,     5,     5,     5,     5,     5,     5,     5,     5,
       5,     5,     5,     5,     5,     5,     5,     5,     5,     5,
       5,     5,     5,     5,     5,     5,     5,     5,     5,     5,
       5,     5,     3,     4,     4,     5,     3,     4,     4,     3,
       4,     4,    10,    10,     4,     2,     1,     2,     3,     1,
       1,     1,     3,     2,     2,     2,     2,     1,     1,     2,
       5,     5,     5,     5,     5,     5,     2,     5,     5,     5,
       5,     5,     5,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     2,     0,     2,
       1,     2,     0,     2,     1,     1,     1,     1,     3,     3,
       4,     4,     5,     3,     0,     3,     4,     6,     6,     8,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     5
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,     0,    16,     1,     2,   122,    21,
     122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
     122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
     122,   122,   122,   122,   122,   122,   122,   122,   122,   122,
     122,     0,     0,     0,     0,    66,     0,    69,    70,    71,
       0,     0,     0,     0,    77,    78,     0,     0,   122,   122,
     122,   122,   122,     0,   122,   122,   122,   122,   122,   122,
       0,    17,    18,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   187,   188,   189,   190,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,     0,   122,   122,     0,     0,     0,   145,
     146,   147,   148,   149,   150,   151,   153,   152,   154,   155,
     156,   157,   158,   160,   161,   162,   163,   159,   164,     0,
       0,    65,   127,   134,   165,   166,   167,   168,   169,   170,
      67,     0,     0,    73,    74,    75,    76,    79,     0,     0,
       0,     0,     0,     0,    95,    96,    97,    98,    99,   100,
     101,   103,   102,   104,   106,   105,   107,   108,   109,   111,
     112,   113,   114,   110,    86,   134,     0,     0,     0,     0,
       0,     0,   118,     0,    19,   124,   125,   126,     0,   123,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     185,   186,    59,    56,    52,     0,     0,     0,     0,     0,
     118,   134,     0,     0,   118,    68,    72,     0,     0,     0,
       0,     0,     0,     0,    94,    93,     0,     0,     0,     0,
       0,     0,     0,     0,   118,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    57,    53,    54,    61,
      58,    60,     0,    64,     0,   133,   118,   128,   143,   144,
     140,     0,   118,   142,   129,   118,     0,     0,     0,     0,
       0,     0,   116,   115,     0,     0,     0,     0,     0,     0,
     120,   119,   191,     0,    20,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      38,    37,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    55,     0,     0,   131,   118,
     135,     0,     0,   130,    80,    81,    82,    83,    84,    85,
     117,    87,    90,    91,    88,    89,    92,   121,   192,     0,
       0,   132,   141,   118,   136,     0,     0,     0,     0,     0,
       0,     0,   137,     0,   138,     0,     0,     0,     0,    62,
      63,   139
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    14,    15,    17,    81,    82,   204,   205,   274,   343,
     283,   351,    84,   219,   161,   162,   264,   331,   335,   332,
     163,   171,   134,   253,   135,    83
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -403
static const yytype_int16 yypact[] =
{
     242,  -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,
    -403,  -403,  -403,  -403,    11,  -403,  -403,   159,  -403,  -403,
    -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,
    -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,
    -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,
     350,   -44,   -39,     4,   349,  -403,   292,  -403,  -403,    44,
     349,   349,   349,   349,  -403,  -403,   349,    44,  -403,  -403,
    -403,  -403,  -403,   195,  -403,  -403,  -403,  -403,  -403,  -403,
     -83,  -403,  -403,   480,    19,    19,    19,    19,    19,    19,
      19,    19,    19,    19,    19,    19,    19,    19,    19,    19,
      19,    19,    19,    19,    19,    19,    19,    19,    19,    19,
      19,    19,    19,    19,    19,  -403,  -403,  -403,  -403,  -403,
    -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,
    -403,  -403,  -403,    40,     9,  -403,   -61,   -23,   -18,  -403,
    -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,
    -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,   370,
     370,   -14,  -403,   -11,  -403,  -403,  -403,  -403,  -403,  -403,
     -14,   349,   349,   -14,   -14,   -14,   -14,   -14,   195,    19,
      19,    19,    19,    19,  -403,  -403,  -403,  -403,  -403,  -403,
    -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,  -403,
    -403,  -403,  -403,  -403,  -403,  -109,    19,    19,    19,    19,
      19,    19,    -8,    41,  -403,  -403,  -403,  -403,    -5,  -403,
       3,     7,    14,    21,    22,    23,    93,    94,    95,    96,
      97,   155,   156,   163,   164,   210,   211,   212,   213,   219,
     237,   247,   248,   249,   250,   251,   252,   253,   254,   255,
    -403,  -403,  -403,   256,   256,    43,     5,     6,   257,   260,
      -8,   -11,   349,   -65,     1,   -14,   -14,   259,   261,   262,
     269,   271,   272,     8,  -403,  -403,   273,   274,   275,   276,
     278,   279,   263,   270,    -8,   349,   349,   349,   349,   349,
     349,   349,   349,   349,   349,   349,   349,   349,   349,   349,
     349,   349,   349,   349,   349,   349,   349,   349,   349,   349,
     349,   349,   349,   349,   349,   349,  -403,  -403,   256,  -403,
    -403,  -403,   282,  -403,   315,  -403,     1,  -403,  -403,  -403,
    -403,  -120,    -8,  -403,  -403,    -8,   349,   349,   349,   349,
     349,   349,  -403,   328,   349,   349,   349,   349,   349,   349,
    -403,   329,  -403,   321,   -14,   -14,   -14,   -14,   -14,   -14,
     -14,   -14,   -14,   -14,   -14,   -14,   -14,   -14,   -14,   -14,
     -14,   -14,   -14,   -14,   -14,   -14,   -14,   -14,   -14,   -14,
     -14,   -14,   -14,   -14,   -14,  -403,   351,   352,  -403,    -8,
    -403,   -63,  -108,  -403,   -14,   -14,   -14,   -14,   -14,   -14,
    -403,   -14,   -14,   -14,   -14,   -14,   -14,  -403,  -403,   347,
     348,  -403,  -403,    -8,  -403,   416,   417,   418,  -106,   -67,
     419,   420,  -403,   416,  -403,   423,   424,   425,   -57,  -403,
    -403,  -403
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -403,  -403,  -403,  -403,  -403,   465,   -51,  -403,  -251,  -403,
    -252,  -403,   277,  -403,   -56,   287,  -196,  -402,   229,   165,
     -78,   -45,  -403,  -134,  -403,  -403
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint16 yytable[] =
{
     170,   212,   316,   317,   173,   174,   175,   176,   325,   275,
     177,    16,   334,   419,   172,   390,   391,   328,   329,   328,
     329,   428,   178,   273,   136,   263,   213,   414,   415,   422,
     423,   137,   353,   218,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   330,   326,   412,   385,   424,   425,
     257,   319,   250,   138,   388,   254,   251,   320,   431,   425,
     392,   260,   261,   393,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   215,   216,   217,   250,   258,   333,
     250,   251,   252,   259,   251,   265,   266,   262,   215,   216,
     217,   318,   321,   263,   282,   284,   285,   267,   268,   269,
     270,   271,   272,   282,   286,   322,   342,   411,   287,   215,
     216,   217,   215,   216,   217,   288,   164,   165,   166,   167,
     168,   169,   289,   290,   291,   276,   277,   278,   279,   280,
     281,   418,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,   292,   293,   294,   295,   296,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     394,   395,   396,   397,   398,   399,   297,   298,   401,   402,
     403,   404,   405,   406,   299,   300,    80,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   133,     1,     2,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,   301,   302,   303,   304,   179,   180,   181,   182,   183,
     305,   206,   207,   208,   209,   210,   211,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   306,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   323,   273,   324,
     336,   350,   337,   338,   164,   165,   166,   167,   168,   169,
     339,   159,   340,   341,   344,   345,   346,   347,   352,   348,
     349,   255,   256,   386,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   160,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   387,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   400,   407,   159,   408,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   416,   417,
     409,   410,   160,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,   330,   420,   421,   214,   327,
     426,   427,   412,   429,   430,   389,   413
};

static const yytype_uint16 yycheck[] =
{
      56,    84,   253,   254,    60,    61,    62,    63,   260,   205,
      66,     0,   264,   415,    59,   135,   136,    82,    83,    82,
      83,   423,    67,   132,    68,   134,   109,   135,   136,   135,
     136,    70,   284,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   129,   261,   129,   318,   135,   136,
     131,    66,    67,    69,   326,    66,    71,    72,   135,   136,
     332,   159,   160,   335,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    99,   100,   101,    67,   131,   108,
      67,    71,    72,   131,    71,   171,   172,   131,    99,   100,
     101,   255,   256,   134,   132,    84,   131,   178,   179,   180,
     181,   182,   183,   132,   131,   129,   128,   389,   131,    99,
     100,   101,    99,   100,   101,   131,   102,   103,   104,   105,
     106,   107,   131,   131,   131,   206,   207,   208,   209,   210,
     211,   413,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,   131,   131,   131,   131,   131,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
     336,   337,   338,   339,   340,   341,   131,   131,   344,   345,
     346,   347,   348,   349,   131,   131,   137,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,   131,   131,   131,   131,    68,    69,    70,    71,    72,
     131,    74,    75,    76,    77,    78,    79,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,   131,    77,
      78,    79,    80,    81,    82,    83,    84,    85,   131,   131,
     131,   131,   131,   131,   131,   131,   131,   130,   132,   129,
     131,   128,   131,   131,   102,   103,   104,   105,   106,   107,
     131,   109,   131,   131,   131,   131,   131,   131,   138,   131,
     131,   134,   135,   131,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,   133,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,   131,    77,    78,    79,
      80,    81,    82,    83,    84,    85,   128,   128,   109,   138,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   131,   131,
     129,   129,   133,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,   129,   129,   129,    83,   262,
     131,   131,   129,   129,   129,   326,   391
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,   140,   141,     0,   142,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
     137,   143,   144,   164,   151,   151,   151,   151,   151,   151,
     151,   151,   151,   151,   151,   151,   151,   151,   151,   151,
     151,   151,   151,   151,   151,   151,   151,   151,   151,   151,
     151,   151,   151,   151,   151,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   151,   161,   163,    68,    70,    69,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      77,    78,    79,    80,    81,    82,    83,    84,    85,   109,
     133,   153,   154,   159,   102,   103,   104,   105,   106,   107,
     153,   160,   160,   153,   153,   153,   153,   153,   160,   151,
     151,   151,   151,   151,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,   145,   146,   151,   151,   151,   151,
     151,   151,    84,   109,   144,    99,   100,   101,   145,   152,
     145,   145,   145,   145,   145,   145,   145,   145,   145,   145,
     145,   145,   145,   145,   145,   145,   145,   145,   145,   145,
     145,   145,   145,   145,   145,   145,   145,   145,   145,   145,
      67,    71,    72,   162,    66,   151,   151,   131,   131,   131,
     159,   159,   131,   134,   155,   153,   153,   145,   145,   145,
     145,   145,   145,   132,   147,   155,   145,   145,   145,   145,
     145,   145,   132,   149,    84,   131,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   131,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   131,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   131,   147,   147,   162,    66,
      72,   162,   129,   130,   129,   149,   155,   154,    82,    83,
     129,   156,   158,   108,   149,   157,   131,   131,   131,   131,
     131,   131,   128,   148,   131,   131,   131,   131,   131,   131,
     128,   150,   138,   149,   153,   153,   153,   153,   153,   153,
     153,   153,   153,   153,   153,   153,   153,   153,   153,   153,
     153,   153,   153,   153,   153,   153,   153,   153,   153,   153,
     153,   153,   153,   153,   153,   147,   131,   131,   149,   157,
     135,   136,   149,   149,   153,   153,   153,   153,   153,   153,
     128,   153,   153,   153,   153,   153,   153,   128,   138,   129,
     129,   149,   129,   158,   135,   136,   131,   131,   149,   156,
     129,   129,   135,   136,   135,   136,   131,   131,   156,   129,
     129,   135
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1464 of yacc.c  */
#line 268 "asmshader.y"
    {
                            asm_ctx.funcs->end(&asm_ctx);
                        ;}
    break;

  case 3:

/* Line 1464 of yacc.c  */
#line 273 "asmshader.y"
    {
                            TRACE("Vertex shader 1.0\n");
                            create_vs10_parser(&asm_ctx);
                        ;}
    break;

  case 4:

/* Line 1464 of yacc.c  */
#line 278 "asmshader.y"
    {
                            TRACE("Vertex shader 1.1\n");
                            create_vs11_parser(&asm_ctx);
                        ;}
    break;

  case 5:

/* Line 1464 of yacc.c  */
#line 283 "asmshader.y"
    {
                            TRACE("Vertex shader 2.0\n");
                            create_vs20_parser(&asm_ctx);
                        ;}
    break;

  case 6:

/* Line 1464 of yacc.c  */
#line 288 "asmshader.y"
    {
                            TRACE("Vertex shader 2.x\n");
                            create_vs2x_parser(&asm_ctx);
                        ;}
    break;

  case 7:

/* Line 1464 of yacc.c  */
#line 293 "asmshader.y"
    {
                            TRACE("Vertex shader 3.0\n");
                            create_vs30_parser(&asm_ctx);
                        ;}
    break;

  case 8:

/* Line 1464 of yacc.c  */
#line 298 "asmshader.y"
    {
                            TRACE("Pixel  shader 1.0\n");
                            set_parse_status(&asm_ctx, PARSE_ERR);
                            YYABORT;
                        ;}
    break;

  case 9:

/* Line 1464 of yacc.c  */
#line 304 "asmshader.y"
    {
                            TRACE("Pixel  shader 1.1\n");
                            set_parse_status(&asm_ctx, PARSE_ERR);
                            YYABORT;
                        ;}
    break;

  case 10:

/* Line 1464 of yacc.c  */
#line 310 "asmshader.y"
    {
                            TRACE("Pixel  shader 1.2\n");
                            set_parse_status(&asm_ctx, PARSE_ERR);
                            YYABORT;
                        ;}
    break;

  case 11:

/* Line 1464 of yacc.c  */
#line 316 "asmshader.y"
    {
                            TRACE("Pixel  shader 1.3\n");
                            set_parse_status(&asm_ctx, PARSE_ERR);
                            YYABORT;
                        ;}
    break;

  case 12:

/* Line 1464 of yacc.c  */
#line 322 "asmshader.y"
    {
                            TRACE("Pixel  shader 1.4\n");
                            set_parse_status(&asm_ctx, PARSE_ERR);
                            YYABORT;
                        ;}
    break;

  case 13:

/* Line 1464 of yacc.c  */
#line 328 "asmshader.y"
    {
                            TRACE("Pixel  shader 2.0\n");
                            create_ps20_parser(&asm_ctx);
                        ;}
    break;

  case 14:

/* Line 1464 of yacc.c  */
#line 333 "asmshader.y"
    {
                            TRACE("Pixel  shader 2.x\n");
                            create_ps2x_parser(&asm_ctx);
                        ;}
    break;

  case 15:

/* Line 1464 of yacc.c  */
#line 338 "asmshader.y"
    {
                            TRACE("Pixel  shader 3.0\n");
                            create_ps30_parser(&asm_ctx);
                        ;}
    break;

  case 17:

/* Line 1464 of yacc.c  */
#line 345 "asmshader.y"
    {
                                /* Nothing to do */
                            ;}
    break;

  case 18:

/* Line 1464 of yacc.c  */
#line 350 "asmshader.y"
    {

                            ;}
    break;

  case 19:

/* Line 1464 of yacc.c  */
#line 354 "asmshader.y"
    {
                                TRACE("predicate\n");
                                asm_ctx.funcs->predicate(&asm_ctx, &(yyvsp[(1) - (2)].reg));
                            ;}
    break;

  case 20:

/* Line 1464 of yacc.c  */
#line 360 "asmshader.y"
    {
                                TRACE("ADD\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_ADD, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 21:

/* Line 1464 of yacc.c  */
#line 365 "asmshader.y"
    {
                                TRACE("NOP\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_NOP, 0, 0, 0, 0, 0, 0);
                            ;}
    break;

  case 22:

/* Line 1464 of yacc.c  */
#line 370 "asmshader.y"
    {
                                TRACE("MOV\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_MOV, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 1);
                            ;}
    break;

  case 23:

/* Line 1464 of yacc.c  */
#line 375 "asmshader.y"
    {
                                TRACE("SUB\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_SUB, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 24:

/* Line 1464 of yacc.c  */
#line 380 "asmshader.y"
    {
                                TRACE("MAD\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_MAD, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 3);
                            ;}
    break;

  case 25:

/* Line 1464 of yacc.c  */
#line 385 "asmshader.y"
    {
                                TRACE("MUL\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_MUL, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 26:

/* Line 1464 of yacc.c  */
#line 390 "asmshader.y"
    {
                                TRACE("RCP\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_RCP, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 1);
                            ;}
    break;

  case 27:

/* Line 1464 of yacc.c  */
#line 395 "asmshader.y"
    {
                                TRACE("RSQ\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_RSQ, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 1);
                            ;}
    break;

  case 28:

/* Line 1464 of yacc.c  */
#line 400 "asmshader.y"
    {
                                TRACE("DP3\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_DP3, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 29:

/* Line 1464 of yacc.c  */
#line 405 "asmshader.y"
    {
                                TRACE("DP4\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_DP4, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 30:

/* Line 1464 of yacc.c  */
#line 410 "asmshader.y"
    {
                                TRACE("MIN\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_MIN, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 31:

/* Line 1464 of yacc.c  */
#line 415 "asmshader.y"
    {
                                TRACE("MAX\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_MAX, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 32:

/* Line 1464 of yacc.c  */
#line 420 "asmshader.y"
    {
                                TRACE("SLT\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_SLT, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 33:

/* Line 1464 of yacc.c  */
#line 425 "asmshader.y"
    {
                                TRACE("SGE\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_SGE, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 34:

/* Line 1464 of yacc.c  */
#line 430 "asmshader.y"
    {
                                TRACE("ABS\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_ABS, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 1);
                            ;}
    break;

  case 35:

/* Line 1464 of yacc.c  */
#line 435 "asmshader.y"
    {
                                TRACE("EXP\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_EXP, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 1);
                            ;}
    break;

  case 36:

/* Line 1464 of yacc.c  */
#line 440 "asmshader.y"
    {
                                TRACE("LOG\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_LOG, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 1);
                            ;}
    break;

  case 37:

/* Line 1464 of yacc.c  */
#line 445 "asmshader.y"
    {
                                TRACE("LOGP\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_LOGP, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 1);
                            ;}
    break;

  case 38:

/* Line 1464 of yacc.c  */
#line 450 "asmshader.y"
    {
                                TRACE("EXPP\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_EXPP, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 1);
                            ;}
    break;

  case 39:

/* Line 1464 of yacc.c  */
#line 455 "asmshader.y"
    {
                                TRACE("DST\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_DST, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 40:

/* Line 1464 of yacc.c  */
#line 460 "asmshader.y"
    {
                                TRACE("LRP\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_LRP, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 3);
                            ;}
    break;

  case 41:

/* Line 1464 of yacc.c  */
#line 465 "asmshader.y"
    {
                                TRACE("FRC\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_FRC, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 1);
                            ;}
    break;

  case 42:

/* Line 1464 of yacc.c  */
#line 470 "asmshader.y"
    {
                                TRACE("POW\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_POW, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 43:

/* Line 1464 of yacc.c  */
#line 475 "asmshader.y"
    {
                                TRACE("CRS\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_CRS, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 44:

/* Line 1464 of yacc.c  */
#line 480 "asmshader.y"
    {
                                TRACE("SGN\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_SGN, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 3);
                            ;}
    break;

  case 45:

/* Line 1464 of yacc.c  */
#line 485 "asmshader.y"
    {
                                TRACE("NRM\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_NRM, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 1);
                            ;}
    break;

  case 46:

/* Line 1464 of yacc.c  */
#line 490 "asmshader.y"
    {
                                TRACE("SINCOS\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_SINCOS, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 1);
                            ;}
    break;

  case 47:

/* Line 1464 of yacc.c  */
#line 495 "asmshader.y"
    {
                                TRACE("M4x4\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_M4x4, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 48:

/* Line 1464 of yacc.c  */
#line 500 "asmshader.y"
    {
                                TRACE("M4x3\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_M4x3, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 49:

/* Line 1464 of yacc.c  */
#line 505 "asmshader.y"
    {
                                TRACE("M3x4\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_M3x4, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 50:

/* Line 1464 of yacc.c  */
#line 510 "asmshader.y"
    {
                                TRACE("M3x3\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_M3x3, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 51:

/* Line 1464 of yacc.c  */
#line 515 "asmshader.y"
    {
                                TRACE("M3x2\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_M3x2, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 52:

/* Line 1464 of yacc.c  */
#line 520 "asmshader.y"
    {
                                struct shader_reg reg;
                                TRACE("Output reg declaration\n");
                                ZeroMemory(&reg, sizeof(reg));
                                reg.type = BWRITERSPR_OUTPUT;
                                reg.regnum = (yyvsp[(3) - (3)].regnum);
                                reg.rel_reg = NULL;
                                reg.srcmod = 0;
                                reg.writemask = BWRITERSP_WRITEMASK_ALL;
                                asm_ctx.funcs->dcl_output(&asm_ctx, (yyvsp[(2) - (3)].declaration).dclusage, (yyvsp[(2) - (3)].declaration).regnum, &reg);
                            ;}
    break;

  case 53:

/* Line 1464 of yacc.c  */
#line 532 "asmshader.y"
    {
                                struct shader_reg reg;
                                TRACE("Output reg declaration\n");
                                ZeroMemory(&reg, sizeof(reg));
                                reg.type = BWRITERSPR_OUTPUT;
                                reg.regnum = (yyvsp[(3) - (4)].regnum);
                                reg.rel_reg = NULL;
                                reg.srcmod = 0;
                                reg.writemask = (yyvsp[(4) - (4)].writemask);
                                asm_ctx.funcs->dcl_output(&asm_ctx, (yyvsp[(2) - (4)].declaration).dclusage, (yyvsp[(2) - (4)].declaration).regnum, &reg);
                            ;}
    break;

  case 54:

/* Line 1464 of yacc.c  */
#line 544 "asmshader.y"
    {
                                struct shader_reg reg;
                                TRACE("Input reg declaration\n");
                                if((yyvsp[(3) - (4)].modshift).shift != 0) {
                                    asmparser_message(&asm_ctx, "Line %u: Shift modifier not allowed here\n",
                                                      asm_ctx.line_no);
                                    set_parse_status(&asm_ctx, PARSE_ERR);
                                }
                                ZeroMemory(&reg, sizeof(reg));
                                reg.type = (yyvsp[(4) - (4)].reg).type;
                                reg.regnum = (yyvsp[(4) - (4)].reg).regnum;
                                reg.rel_reg = NULL;
                                reg.srcmod = 0;
                                reg.writemask = BWRITERSP_WRITEMASK_ALL;
                                asm_ctx.funcs->dcl_input(&asm_ctx, (yyvsp[(2) - (4)].declaration).dclusage, (yyvsp[(2) - (4)].declaration).regnum, (yyvsp[(3) - (4)].modshift).mod, &reg);
                            ;}
    break;

  case 55:

/* Line 1464 of yacc.c  */
#line 561 "asmshader.y"
    {
                                struct shader_reg reg;
                                TRACE("Input reg declaration\n");
                                if((yyvsp[(3) - (5)].modshift).shift != 0) {
                                    asmparser_message(&asm_ctx, "Line %u: Shift modifier not allowed here\n",
                                                      asm_ctx.line_no);
                                    set_parse_status(&asm_ctx, PARSE_ERR);
                                }
                                ZeroMemory(&reg, sizeof(reg));
                                reg.type = (yyvsp[(4) - (5)].reg).type;
                                reg.regnum = (yyvsp[(4) - (5)].reg).regnum;
                                reg.rel_reg = NULL;
                                reg.srcmod = 0;
                                reg.writemask = (yyvsp[(5) - (5)].writemask);
                                asm_ctx.funcs->dcl_input(&asm_ctx, (yyvsp[(2) - (5)].declaration).dclusage, (yyvsp[(2) - (5)].declaration).regnum, (yyvsp[(3) - (5)].modshift).mod, &reg);
                            ;}
    break;

  case 56:

/* Line 1464 of yacc.c  */
#line 578 "asmshader.y"
    {
                                struct shader_reg reg;
                                TRACE("Input reg declaration\n");
                                if((yyvsp[(2) - (3)].modshift).shift != 0) {
                                    asmparser_message(&asm_ctx, "Line %u: Shift modifier not allowed here\n",
                                                      asm_ctx.line_no);
                                    set_parse_status(&asm_ctx, PARSE_ERR);
                                }
                                ZeroMemory(&reg, sizeof(reg));
                                reg.type = (yyvsp[(3) - (3)].reg).type;
                                reg.regnum = (yyvsp[(3) - (3)].reg).regnum;
                                reg.rel_reg = NULL;
                                reg.srcmod = 0;
                                reg.writemask = BWRITERSP_WRITEMASK_ALL;
                                asm_ctx.funcs->dcl_input(&asm_ctx, 0, 0, (yyvsp[(2) - (3)].modshift).mod, &reg);
                            ;}
    break;

  case 57:

/* Line 1464 of yacc.c  */
#line 595 "asmshader.y"
    {
                                struct shader_reg reg;
                                TRACE("Input reg declaration\n");
                                if((yyvsp[(2) - (4)].modshift).shift != 0) {
                                    asmparser_message(&asm_ctx, "Line %u: Shift modifier not allowed here\n",
                                                      asm_ctx.line_no);
                                    set_parse_status(&asm_ctx, PARSE_ERR);
                                }
                                ZeroMemory(&reg, sizeof(reg));
                                reg.type = (yyvsp[(3) - (4)].reg).type;
                                reg.regnum = (yyvsp[(3) - (4)].reg).regnum;
                                reg.rel_reg = NULL;
                                reg.srcmod = 0;
                                reg.writemask = (yyvsp[(4) - (4)].writemask);
                                asm_ctx.funcs->dcl_input(&asm_ctx, 0, 0, (yyvsp[(2) - (4)].modshift).mod, &reg);
                            ;}
    break;

  case 58:

/* Line 1464 of yacc.c  */
#line 612 "asmshader.y"
    {
                                TRACE("Sampler declared\n");
                                if((yyvsp[(3) - (4)].modshift).shift != 0) {
                                    asmparser_message(&asm_ctx, "Line %u: Shift modifier not allowed here\n",
                                                      asm_ctx.line_no);
                                    set_parse_status(&asm_ctx, PARSE_ERR);
                                }
                                asm_ctx.funcs->dcl_sampler(&asm_ctx, (yyvsp[(2) - (4)].samplertype), (yyvsp[(3) - (4)].modshift).mod, (yyvsp[(4) - (4)].regnum), asm_ctx.line_no);
                            ;}
    break;

  case 59:

/* Line 1464 of yacc.c  */
#line 622 "asmshader.y"
    {
                                TRACE("Sampler declared\n");
                                if((yyvsp[(2) - (3)].modshift).shift != 0) {
                                    asmparser_message(&asm_ctx, "Line %u: Shift modifier not allowed here\n",
                                                      asm_ctx.line_no);
                                    set_parse_status(&asm_ctx, PARSE_ERR);
                                }
                                if(asm_ctx.shader->type != ST_PIXEL) {
                                    asmparser_message(&asm_ctx, "Line %u: Declaration needs a sampler type\n",
                                                      asm_ctx.line_no);
                                    set_parse_status(&asm_ctx, PARSE_ERR);
                                }
                                asm_ctx.funcs->dcl_sampler(&asm_ctx, BWRITERSTT_UNKNOWN, (yyvsp[(2) - (3)].modshift).mod, (yyvsp[(3) - (3)].regnum), asm_ctx.line_no);
                            ;}
    break;

  case 60:

/* Line 1464 of yacc.c  */
#line 637 "asmshader.y"
    {
                                TRACE("Error rule: sampler decl of input reg\n");
                                asmparser_message(&asm_ctx, "Line %u: Sampler declarations of input regs is not valid\n",
                                                  asm_ctx.line_no);
                                set_parse_status(&asm_ctx, PARSE_WARN);
                            ;}
    break;

  case 61:

/* Line 1464 of yacc.c  */
#line 644 "asmshader.y"
    {
                                TRACE("Error rule: sampler decl of output reg\n");
                                asmparser_message(&asm_ctx, "Line %u: Sampler declarations of output regs is not valid\n",
                                                  asm_ctx.line_no);
                                set_parse_status(&asm_ctx, PARSE_WARN);
                            ;}
    break;

  case 62:

/* Line 1464 of yacc.c  */
#line 651 "asmshader.y"
    {
                                asm_ctx.funcs->constF(&asm_ctx, (yyvsp[(2) - (10)].regnum), (yyvsp[(4) - (10)].immval).val, (yyvsp[(6) - (10)].immval).val, (yyvsp[(8) - (10)].immval).val, (yyvsp[(10) - (10)].immval).val);
                            ;}
    break;

  case 63:

/* Line 1464 of yacc.c  */
#line 655 "asmshader.y"
    {
                                asm_ctx.funcs->constI(&asm_ctx, (yyvsp[(2) - (10)].regnum), (yyvsp[(4) - (10)].immval).val, (yyvsp[(6) - (10)].immval).val, (yyvsp[(8) - (10)].immval).val, (yyvsp[(10) - (10)].immval).val);
                            ;}
    break;

  case 64:

/* Line 1464 of yacc.c  */
#line 659 "asmshader.y"
    {
                                asm_ctx.funcs->constB(&asm_ctx, (yyvsp[(2) - (4)].regnum), (yyvsp[(4) - (4)].immbool));
                            ;}
    break;

  case 65:

/* Line 1464 of yacc.c  */
#line 663 "asmshader.y"
    {
                                TRACE("REP\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_REP, 0, 0, 0, 0, &(yyvsp[(2) - (2)].sregs), 1);
                            ;}
    break;

  case 66:

/* Line 1464 of yacc.c  */
#line 668 "asmshader.y"
    {
                                TRACE("ENDREP\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_ENDREP, 0, 0, 0, 0, 0, 0);
                            ;}
    break;

  case 67:

/* Line 1464 of yacc.c  */
#line 673 "asmshader.y"
    {
                                TRACE("IF\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_IF, 0, 0, 0, 0, &(yyvsp[(2) - (2)].sregs), 1);
                            ;}
    break;

  case 68:

/* Line 1464 of yacc.c  */
#line 678 "asmshader.y"
    {
                                TRACE("IFC\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_IFC, 0, 0, (yyvsp[(2) - (3)].comptype), 0, &(yyvsp[(3) - (3)].sregs), 2);
                            ;}
    break;

  case 69:

/* Line 1464 of yacc.c  */
#line 683 "asmshader.y"
    {
                                TRACE("ELSE\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_ELSE, 0, 0, 0, 0, 0, 0);
                            ;}
    break;

  case 70:

/* Line 1464 of yacc.c  */
#line 688 "asmshader.y"
    {
                                TRACE("ENDIF\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_ENDIF, 0, 0, 0, 0, 0, 0);
                            ;}
    break;

  case 71:

/* Line 1464 of yacc.c  */
#line 693 "asmshader.y"
    {
                                TRACE("BREAK\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_BREAK, 0, 0, 0, 0, 0, 0);
                            ;}
    break;

  case 72:

/* Line 1464 of yacc.c  */
#line 698 "asmshader.y"
    {
                                TRACE("BREAKC\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_BREAKC, 0, 0, (yyvsp[(2) - (3)].comptype), 0, &(yyvsp[(3) - (3)].sregs), 2);
                            ;}
    break;

  case 73:

/* Line 1464 of yacc.c  */
#line 703 "asmshader.y"
    {
                                TRACE("BREAKP\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_BREAKP, 0, 0, 0, 0, &(yyvsp[(2) - (2)].sregs), 1);
                            ;}
    break;

  case 74:

/* Line 1464 of yacc.c  */
#line 708 "asmshader.y"
    {
                                TRACE("CALL\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_CALL, 0, 0, 0, 0, &(yyvsp[(2) - (2)].sregs), 1);
                            ;}
    break;

  case 75:

/* Line 1464 of yacc.c  */
#line 713 "asmshader.y"
    {
                                TRACE("CALLNZ\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_CALLNZ, 0, 0, 0, 0, &(yyvsp[(2) - (2)].sregs), 2);
                            ;}
    break;

  case 76:

/* Line 1464 of yacc.c  */
#line 718 "asmshader.y"
    {
                                TRACE("LOOP\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_LOOP, 0, 0, 0, 0, &(yyvsp[(2) - (2)].sregs), 2);
                            ;}
    break;

  case 77:

/* Line 1464 of yacc.c  */
#line 723 "asmshader.y"
    {
                                TRACE("RET\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_RET, 0, 0, 0, 0, 0, 0);
                            ;}
    break;

  case 78:

/* Line 1464 of yacc.c  */
#line 728 "asmshader.y"
    {
                                TRACE("ENDLOOP\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_ENDLOOP, 0, 0, 0, 0, 0, 0);
                            ;}
    break;

  case 79:

/* Line 1464 of yacc.c  */
#line 733 "asmshader.y"
    {
                                TRACE("LABEL\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_LABEL, 0, 0, 0, 0, &(yyvsp[(2) - (2)].sregs), 1);
                            ;}
    break;

  case 80:

/* Line 1464 of yacc.c  */
#line 738 "asmshader.y"
    {
                                TRACE("SETP\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_SETP, 0, 0, (yyvsp[(2) - (5)].comptype), &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 81:

/* Line 1464 of yacc.c  */
#line 743 "asmshader.y"
    {
                                TRACE("TEXLDL\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_TEXLDL, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 82:

/* Line 1464 of yacc.c  */
#line 748 "asmshader.y"
    {
                                TRACE("LIT\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_LIT, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 1);
                            ;}
    break;

  case 83:

/* Line 1464 of yacc.c  */
#line 753 "asmshader.y"
    {
                                TRACE("MOVA\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_MOVA, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 1);
                            ;}
    break;

  case 84:

/* Line 1464 of yacc.c  */
#line 758 "asmshader.y"
    {
                                TRACE("CMP\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_CMP, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 3);
                            ;}
    break;

  case 85:

/* Line 1464 of yacc.c  */
#line 763 "asmshader.y"
    {
                                TRACE("DP2ADD\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_DP2ADD, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 3);
                            ;}
    break;

  case 86:

/* Line 1464 of yacc.c  */
#line 768 "asmshader.y"
    {
                                TRACE("TEXKILL\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_TEXKILL, 0, 0, 0, &(yyvsp[(2) - (2)].reg), 0, 0);
                            ;}
    break;

  case 87:

/* Line 1464 of yacc.c  */
#line 773 "asmshader.y"
    {
                                TRACE("TEXLD\n");
                                /* There is more than one acceptable syntax for texld:
                                   with 1 sreg (PS 1.4) or
                                   with 2 sregs (PS 2.0+)
                                   Moreover, texld shares the same opcode as the tex instruction,
                                   so there are a total of 3 valid syntaxes
                                   These variations are handled in asmparser.c */
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_TEX, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 88:

/* Line 1464 of yacc.c  */
#line 784 "asmshader.y"
    {
                                TRACE("TEXLDP\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_TEXLDP, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 89:

/* Line 1464 of yacc.c  */
#line 789 "asmshader.y"
    {
                                TRACE("TEXLDB\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_TEXLDB, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 2);
                            ;}
    break;

  case 90:

/* Line 1464 of yacc.c  */
#line 794 "asmshader.y"
    {
                                TRACE("DSX\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_DSX, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 1);
                            ;}
    break;

  case 91:

/* Line 1464 of yacc.c  */
#line 799 "asmshader.y"
    {
                                TRACE("DSY\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_DSY, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 1);
                            ;}
    break;

  case 92:

/* Line 1464 of yacc.c  */
#line 804 "asmshader.y"
    {
                                TRACE("TEXLDD\n");
                                asm_ctx.funcs->instr(&asm_ctx, BWRITERSIO_TEXLDD, (yyvsp[(2) - (5)].modshift).mod, (yyvsp[(2) - (5)].modshift).shift, 0, &(yyvsp[(3) - (5)].reg), &(yyvsp[(5) - (5)].sregs), 4);
                            ;}
    break;

  case 93:

/* Line 1464 of yacc.c  */
#line 810 "asmshader.y"
    {
                                (yyval.reg).regnum = (yyvsp[(1) - (2)].reg).regnum;
                                (yyval.reg).type = (yyvsp[(1) - (2)].reg).type;
                                (yyval.reg).writemask = BWRITERSP_WRITEMASK_ALL;
                                (yyval.reg).srcmod = BWRITERSPSM_NONE;
                                set_rel_reg(&(yyval.reg), &(yyvsp[(2) - (2)].rel_reg));
                            ;}
    break;

  case 94:

/* Line 1464 of yacc.c  */
#line 818 "asmshader.y"
    {
                                (yyval.reg).regnum = (yyvsp[(1) - (2)].reg).regnum;
                                (yyval.reg).type = (yyvsp[(1) - (2)].reg).type;
                                (yyval.reg).writemask = (yyvsp[(2) - (2)].writemask);
                                (yyval.reg).srcmod = BWRITERSPSM_NONE;
                                (yyval.reg).rel_reg = NULL;
                            ;}
    break;

  case 95:

/* Line 1464 of yacc.c  */
#line 827 "asmshader.y"
    {
                            (yyval.reg).regnum = (yyvsp[(1) - (1)].regnum); (yyval.reg).type = BWRITERSPR_TEMP;
                        ;}
    break;

  case 96:

/* Line 1464 of yacc.c  */
#line 831 "asmshader.y"
    {
                            (yyval.reg).regnum = (yyvsp[(1) - (1)].regnum); (yyval.reg).type = BWRITERSPR_OUTPUT;
                        ;}
    break;

  case 97:

/* Line 1464 of yacc.c  */
#line 835 "asmshader.y"
    {
                            (yyval.reg).regnum = (yyvsp[(1) - (1)].regnum); (yyval.reg).type = BWRITERSPR_INPUT;
                        ;}
    break;

  case 98:

/* Line 1464 of yacc.c  */
#line 839 "asmshader.y"
    {
                            asmparser_message(&asm_ctx, "Line %u: Register c%u is not a valid destination register\n",
                                              asm_ctx.line_no, (yyvsp[(1) - (1)].regnum));
                            set_parse_status(&asm_ctx, PARSE_WARN);
                        ;}
    break;

  case 99:

/* Line 1464 of yacc.c  */
#line 845 "asmshader.y"
    {
			  asmparser_message(&asm_ctx, "Line %u: Register i%u is not a valid destination register\n",
                                              asm_ctx.line_no, (yyvsp[(1) - (1)].regnum));
                            set_parse_status(&asm_ctx, PARSE_WARN);
                        ;}
    break;

  case 100:

/* Line 1464 of yacc.c  */
#line 851 "asmshader.y"
    {
                            asmparser_message(&asm_ctx, "Line %u: Register b%u is not a valid destination register\n",
                                              asm_ctx.line_no, (yyvsp[(1) - (1)].regnum));
                            set_parse_status(&asm_ctx, PARSE_WARN);
                        ;}
    break;

  case 101:

/* Line 1464 of yacc.c  */
#line 857 "asmshader.y"
    {
                            (yyval.reg).regnum = (yyvsp[(1) - (1)].regnum); (yyval.reg).type = BWRITERSPR_TEXTURE;
                        ;}
    break;

  case 102:

/* Line 1464 of yacc.c  */
#line 861 "asmshader.y"
    {
                            (yyval.reg).regnum = (yyvsp[(1) - (1)].regnum); (yyval.reg).type = BWRITERSPR_TEXCRDOUT;
                        ;}
    break;

  case 103:

/* Line 1464 of yacc.c  */
#line 865 "asmshader.y"
    {
                            asmparser_message(&asm_ctx, "Line %u: Register s%u is not a valid destination register\n",
                                              asm_ctx.line_no, (yyvsp[(1) - (1)].regnum));
                            set_parse_status(&asm_ctx, PARSE_WARN);
                        ;}
    break;

  case 104:

/* Line 1464 of yacc.c  */
#line 871 "asmshader.y"
    {
                            (yyval.reg).regnum = BWRITERSRO_POSITION; (yyval.reg).type = BWRITERSPR_RASTOUT;
                        ;}
    break;

  case 105:

/* Line 1464 of yacc.c  */
#line 875 "asmshader.y"
    {
                            (yyval.reg).regnum = BWRITERSRO_POINT_SIZE; (yyval.reg).type = BWRITERSPR_RASTOUT;
                        ;}
    break;

  case 106:

/* Line 1464 of yacc.c  */
#line 879 "asmshader.y"
    {
                            (yyval.reg).regnum = BWRITERSRO_FOG; (yyval.reg).type = BWRITERSPR_RASTOUT;
                        ;}
    break;

  case 107:

/* Line 1464 of yacc.c  */
#line 883 "asmshader.y"
    {
                            (yyval.reg).regnum = (yyvsp[(1) - (1)].regnum); (yyval.reg).type = BWRITERSPR_ATTROUT;
                        ;}
    break;

  case 108:

/* Line 1464 of yacc.c  */
#line 887 "asmshader.y"
    {
                            (yyval.reg).regnum = (yyvsp[(1) - (1)].regnum); (yyval.reg).type = BWRITERSPR_COLOROUT;
                        ;}
    break;

  case 109:

/* Line 1464 of yacc.c  */
#line 891 "asmshader.y"
    {
                            (yyval.reg).regnum = 0; (yyval.reg).type = BWRITERSPR_DEPTHOUT;
                        ;}
    break;

  case 110:

/* Line 1464 of yacc.c  */
#line 895 "asmshader.y"
    {
                            (yyval.reg).regnum = 0; (yyval.reg).type = BWRITERSPR_PREDICATE;
                        ;}
    break;

  case 111:

/* Line 1464 of yacc.c  */
#line 899 "asmshader.y"
    {
                            asmparser_message(&asm_ctx, "Line %u: Register vPos is not a valid destination register\n",
                                              asm_ctx.line_no);
                            set_parse_status(&asm_ctx, PARSE_WARN);
                        ;}
    break;

  case 112:

/* Line 1464 of yacc.c  */
#line 905 "asmshader.y"
    {
                            asmparser_message(&asm_ctx, "Line %u: Register vFace is not a valid destination register\n",
                                              asm_ctx.line_no);
                            set_parse_status(&asm_ctx, PARSE_WARN);
                        ;}
    break;

  case 113:

/* Line 1464 of yacc.c  */
#line 911 "asmshader.y"
    {
                            /* index 0 is hardcoded for the addr register */
                            (yyval.reg).regnum = 0; (yyval.reg).type = BWRITERSPR_ADDR;
                        ;}
    break;

  case 114:

/* Line 1464 of yacc.c  */
#line 916 "asmshader.y"
    {
                            asmparser_message(&asm_ctx, "Line %u: Register aL is not a valid destination register\n",
                                              asm_ctx.line_no);
                            set_parse_status(&asm_ctx, PARSE_WARN);
                        ;}
    break;

  case 115:

/* Line 1464 of yacc.c  */
#line 923 "asmshader.y"
    {
                            if((yyvsp[(2) - (2)].wm_components).writemask == SWIZZLE_ERR) {
                                asmparser_message(&asm_ctx, "Line %u: Invalid writemask specified\n",
                                                  asm_ctx.line_no);
                                set_parse_status(&asm_ctx, PARSE_ERR);
                                /* Provide a correct writemask to prevent following complaints */
                                (yyval.writemask) = BWRITERSP_WRITEMASK_ALL;
                            }
                            else {
                                (yyval.writemask) = (yyvsp[(2) - (2)].wm_components).writemask;
                                TRACE("Writemask: %x\n", (yyval.writemask));
                            }
                        ;}
    break;

  case 116:

/* Line 1464 of yacc.c  */
#line 938 "asmshader.y"
    {
                            (yyval.wm_components).writemask = 1 << (yyvsp[(1) - (1)].component);
                            (yyval.wm_components).last = (yyvsp[(1) - (1)].component);
                            (yyval.wm_components).idx = 1;
                        ;}
    break;

  case 117:

/* Line 1464 of yacc.c  */
#line 944 "asmshader.y"
    {
                            if((yyvsp[(1) - (2)].wm_components).writemask == SWIZZLE_ERR || (yyvsp[(1) - (2)].wm_components).idx == 4)
                                /* Wrong writemask */
                                (yyval.wm_components).writemask = SWIZZLE_ERR;
                            else {
                                if((yyvsp[(2) - (2)].component) <= (yyvsp[(1) - (2)].wm_components).last)
                                    (yyval.wm_components).writemask = SWIZZLE_ERR;
                                else {
                                    (yyval.wm_components).writemask = (yyvsp[(1) - (2)].wm_components).writemask | (1 << (yyvsp[(2) - (2)].component));
                                    (yyval.wm_components).idx = (yyvsp[(1) - (2)].wm_components).idx + 1;
                                }
                            }
                        ;}
    break;

  case 118:

/* Line 1464 of yacc.c  */
#line 959 "asmshader.y"
    {
                            (yyval.swizzle) = BWRITERVS_NOSWIZZLE;
                            TRACE("Default swizzle: %08x\n", (yyval.swizzle));
                        ;}
    break;

  case 119:

/* Line 1464 of yacc.c  */
#line 964 "asmshader.y"
    {
                            if((yyvsp[(2) - (2)].sw_components).swizzle == SWIZZLE_ERR) {
                                asmparser_message(&asm_ctx, "Line %u: Invalid swizzle\n",
                                                  asm_ctx.line_no);
                                set_parse_status(&asm_ctx, PARSE_ERR);
                                /* Provide a correct swizzle to prevent following complaints */
                                (yyval.swizzle) = BWRITERVS_NOSWIZZLE;
                            }
                            else {
                                DWORD last, i;

                                (yyval.swizzle) = (yyvsp[(2) - (2)].sw_components).swizzle << BWRITERVS_SWIZZLE_SHIFT;
                                /* Fill the swizzle by extending the last component */
                                last = ((yyvsp[(2) - (2)].sw_components).swizzle >> 2 * ((yyvsp[(2) - (2)].sw_components).idx - 1)) & 0x03;
                                for(i = (yyvsp[(2) - (2)].sw_components).idx; i < 4; i++){
                                    (yyval.swizzle) |= last << (BWRITERVS_SWIZZLE_SHIFT + 2 * i);
                                }
                                TRACE("Got a swizzle: %08x\n", (yyval.swizzle));
                            }
                        ;}
    break;

  case 120:

/* Line 1464 of yacc.c  */
#line 986 "asmshader.y"
    {
                            (yyval.sw_components).swizzle = (yyvsp[(1) - (1)].component);
                            (yyval.sw_components).idx = 1;
                        ;}
    break;

  case 121:

/* Line 1464 of yacc.c  */
#line 991 "asmshader.y"
    {
                            if((yyvsp[(1) - (2)].sw_components).idx == 4) {
                                /* Too many sw_components */
                                (yyval.sw_components).swizzle = SWIZZLE_ERR;
                                (yyval.sw_components).idx = 4;
                            }
                            else {
                                (yyval.sw_components).swizzle = (yyvsp[(1) - (2)].sw_components).swizzle | ((yyvsp[(2) - (2)].component) << 2 * (yyvsp[(1) - (2)].sw_components).idx);
                                (yyval.sw_components).idx = (yyvsp[(1) - (2)].sw_components).idx + 1;
                            }
                        ;}
    break;

  case 122:

/* Line 1464 of yacc.c  */
#line 1004 "asmshader.y"
    {
                            (yyval.modshift).mod = 0;
                            (yyval.modshift).shift = 0;
                        ;}
    break;

  case 123:

/* Line 1464 of yacc.c  */
#line 1009 "asmshader.y"
    {
                            (yyval.modshift).mod = (yyvsp[(1) - (2)].modshift).mod | (yyvsp[(2) - (2)].modshift).mod;
                            if((yyvsp[(1) - (2)].modshift).shift && (yyvsp[(2) - (2)].modshift).shift) {
                                asmparser_message(&asm_ctx, "Line %u: More than one shift flag\n",
                                                  asm_ctx.line_no);
                                set_parse_status(&asm_ctx, PARSE_ERR);
                                (yyval.modshift).shift = (yyvsp[(1) - (2)].modshift).shift;
                            } else {
                                (yyval.modshift).shift = (yyvsp[(1) - (2)].modshift).shift | (yyvsp[(2) - (2)].modshift).shift;
                            }
                        ;}
    break;

  case 124:

/* Line 1464 of yacc.c  */
#line 1022 "asmshader.y"
    {
                            (yyval.modshift).mod = BWRITERSPDM_SATURATE;
                            (yyval.modshift).shift = 0;
                        ;}
    break;

  case 125:

/* Line 1464 of yacc.c  */
#line 1027 "asmshader.y"
    {
                            (yyval.modshift).mod = BWRITERSPDM_PARTIALPRECISION;
                            (yyval.modshift).shift = 0;
                        ;}
    break;

  case 126:

/* Line 1464 of yacc.c  */
#line 1032 "asmshader.y"
    {
                            (yyval.modshift).mod = BWRITERSPDM_MSAMPCENTROID;
                            (yyval.modshift).shift = 0;
                        ;}
    break;

  case 127:

/* Line 1464 of yacc.c  */
#line 1038 "asmshader.y"
    {
                            (yyval.sregs).reg[0] = (yyvsp[(1) - (1)].reg);
                            (yyval.sregs).count = 1;
                        ;}
    break;

  case 128:

/* Line 1464 of yacc.c  */
#line 1043 "asmshader.y"
    {
                            if((yyval.sregs).count == MAX_SRC_REGS){
                                asmparser_message(&asm_ctx, "Line %u: Too many source registers in this instruction\n",
                                                  asm_ctx.line_no);
                                set_parse_status(&asm_ctx, PARSE_ERR);
                            }
                            else
                                (yyval.sregs).reg[(yyval.sregs).count++] = (yyvsp[(3) - (3)].reg);
                        ;}
    break;

  case 129:

/* Line 1464 of yacc.c  */
#line 1054 "asmshader.y"
    {
                            (yyval.reg).type = (yyvsp[(1) - (3)].reg).type;
                            (yyval.reg).regnum = (yyvsp[(1) - (3)].reg).regnum;
                            (yyval.reg).swizzle = (yyvsp[(3) - (3)].swizzle);
                            (yyval.reg).srcmod = BWRITERSPSM_NONE;
                            set_rel_reg(&(yyval.reg), &(yyvsp[(2) - (3)].rel_reg));
                        ;}
    break;

  case 130:

/* Line 1464 of yacc.c  */
#line 1062 "asmshader.y"
    {
                            (yyval.reg).type = (yyvsp[(1) - (4)].reg).type;
                            (yyval.reg).regnum = (yyvsp[(1) - (4)].reg).regnum;
                            set_rel_reg(&(yyval.reg), &(yyvsp[(2) - (4)].rel_reg));
                            (yyval.reg).srcmod = (yyvsp[(3) - (4)].srcmod);
                            (yyval.reg).swizzle = (yyvsp[(4) - (4)].swizzle);
                        ;}
    break;

  case 131:

/* Line 1464 of yacc.c  */
#line 1070 "asmshader.y"
    {
                            (yyval.reg).type = (yyvsp[(2) - (4)].reg).type;
                            (yyval.reg).regnum = (yyvsp[(2) - (4)].reg).regnum;
                            (yyval.reg).srcmod = BWRITERSPSM_NEG;
                            set_rel_reg(&(yyval.reg), &(yyvsp[(3) - (4)].rel_reg));
                            (yyval.reg).swizzle = (yyvsp[(4) - (4)].swizzle);
                        ;}
    break;

  case 132:

/* Line 1464 of yacc.c  */
#line 1078 "asmshader.y"
    {
                            (yyval.reg).type = (yyvsp[(2) - (5)].reg).type;
                            (yyval.reg).regnum = (yyvsp[(2) - (5)].reg).regnum;
                            set_rel_reg(&(yyval.reg), &(yyvsp[(3) - (5)].rel_reg));
                            switch((yyvsp[(4) - (5)].srcmod)) {
                                case BWRITERSPSM_ABS:  (yyval.reg).srcmod = BWRITERSPSM_ABSNEG;  break;
                                default:
                                    FIXME("Unhandled combination of NEGATE and %u\n", (yyvsp[(4) - (5)].srcmod));
                            }
                            (yyval.reg).swizzle = (yyvsp[(5) - (5)].swizzle);
                        ;}
    break;

  case 133:

/* Line 1464 of yacc.c  */
#line 1090 "asmshader.y"
    {
                            (yyval.reg).type = (yyvsp[(2) - (3)].reg).type;
                            (yyval.reg).regnum = (yyvsp[(2) - (3)].reg).regnum;
                            (yyval.reg).rel_reg = NULL;
                            (yyval.reg).srcmod = BWRITERSPSM_NOT;
                            (yyval.reg).swizzle = (yyvsp[(3) - (3)].swizzle);
                        ;}
    break;

  case 134:

/* Line 1464 of yacc.c  */
#line 1099 "asmshader.y"
    {
                            (yyval.rel_reg).has_rel_reg = FALSE;
                            (yyval.rel_reg).additional_offset = 0;
                        ;}
    break;

  case 135:

/* Line 1464 of yacc.c  */
#line 1104 "asmshader.y"
    {
                            (yyval.rel_reg).has_rel_reg = FALSE;
                            (yyval.rel_reg).additional_offset = (yyvsp[(2) - (3)].immval).val;
                        ;}
    break;

  case 136:

/* Line 1464 of yacc.c  */
#line 1109 "asmshader.y"
    {
                            (yyval.rel_reg).has_rel_reg = TRUE;
                            (yyval.rel_reg).type = (yyvsp[(2) - (4)].reg).type;
                            (yyval.rel_reg).additional_offset = 0;
                            (yyval.rel_reg).rel_regnum = (yyvsp[(2) - (4)].reg).regnum;
                            (yyval.rel_reg).swizzle = (yyvsp[(3) - (4)].swizzle);
                        ;}
    break;

  case 137:

/* Line 1464 of yacc.c  */
#line 1117 "asmshader.y"
    {
                            (yyval.rel_reg).has_rel_reg = TRUE;
                            (yyval.rel_reg).type = (yyvsp[(4) - (6)].reg).type;
                            (yyval.rel_reg).additional_offset = (yyvsp[(2) - (6)].immval).val;
                            (yyval.rel_reg).rel_regnum = (yyvsp[(4) - (6)].reg).regnum;
                            (yyval.rel_reg).swizzle = (yyvsp[(5) - (6)].swizzle);
                        ;}
    break;

  case 138:

/* Line 1464 of yacc.c  */
#line 1125 "asmshader.y"
    {
                            (yyval.rel_reg).has_rel_reg = TRUE;
                            (yyval.rel_reg).type = (yyvsp[(2) - (6)].reg).type;
                            (yyval.rel_reg).additional_offset = (yyvsp[(5) - (6)].immval).val;
                            (yyval.rel_reg).rel_regnum = (yyvsp[(2) - (6)].reg).regnum;
                            (yyval.rel_reg).swizzle = (yyvsp[(3) - (6)].swizzle);
                        ;}
    break;

  case 139:

/* Line 1464 of yacc.c  */
#line 1133 "asmshader.y"
    {
                            (yyval.rel_reg).has_rel_reg = TRUE;
                            (yyval.rel_reg).type = (yyvsp[(4) - (8)].reg).type;
                            (yyval.rel_reg).additional_offset = (yyvsp[(2) - (8)].immval).val + (yyvsp[(7) - (8)].immval).val;
                            (yyval.rel_reg).rel_regnum = (yyvsp[(4) - (8)].reg).regnum;
                            (yyval.rel_reg).swizzle = (yyvsp[(5) - (8)].swizzle);
                        ;}
    break;

  case 140:

/* Line 1464 of yacc.c  */
#line 1142 "asmshader.y"
    {
                            if(!(yyvsp[(1) - (1)].immval).integer) {
                                asmparser_message(&asm_ctx, "Line %u: Unexpected float %f\n",
                                                  asm_ctx.line_no, (yyvsp[(1) - (1)].immval).val);
                                set_parse_status(&asm_ctx, PARSE_ERR);
                            }
                            (yyval.immval).val = (yyvsp[(1) - (1)].immval).val;
                        ;}
    break;

  case 141:

/* Line 1464 of yacc.c  */
#line 1151 "asmshader.y"
    {
                            if(!(yyvsp[(3) - (3)].immval).integer) {
                                asmparser_message(&asm_ctx, "Line %u: Unexpected float %f\n",
                                                  asm_ctx.line_no, (yyvsp[(3) - (3)].immval).val);
                                set_parse_status(&asm_ctx, PARSE_ERR);
                            }
                            (yyval.immval).val = (yyvsp[(1) - (3)].immval).val + (yyvsp[(3) - (3)].immval).val;
                        ;}
    break;

  case 142:

/* Line 1464 of yacc.c  */
#line 1161 "asmshader.y"
    {
                            (yyval.srcmod) = BWRITERSPSM_ABS;
                        ;}
    break;

  case 143:

/* Line 1464 of yacc.c  */
#line 1166 "asmshader.y"
    {
                            (yyval.reg).regnum = 0; (yyval.reg).type = BWRITERSPR_ADDR;
                        ;}
    break;

  case 144:

/* Line 1464 of yacc.c  */
#line 1170 "asmshader.y"
    {
                            (yyval.reg).regnum = 0; (yyval.reg).type = BWRITERSPR_LOOP;
                        ;}
    break;

  case 145:

/* Line 1464 of yacc.c  */
#line 1175 "asmshader.y"
    {
                            (yyval.reg).regnum = (yyvsp[(1) - (1)].regnum); (yyval.reg).type = BWRITERSPR_TEMP;
                        ;}
    break;

  case 146:

/* Line 1464 of yacc.c  */
#line 1179 "asmshader.y"
    {
                            asmparser_message(&asm_ctx, "Line %u: Register o%u is not a valid source register\n",
                                              asm_ctx.line_no, (yyvsp[(1) - (1)].regnum));
                            set_parse_status(&asm_ctx, PARSE_WARN);
                        ;}
    break;

  case 147:

/* Line 1464 of yacc.c  */
#line 1185 "asmshader.y"
    {
                            (yyval.reg).regnum = (yyvsp[(1) - (1)].regnum); (yyval.reg).type = BWRITERSPR_INPUT;
                        ;}
    break;

  case 148:

/* Line 1464 of yacc.c  */
#line 1189 "asmshader.y"
    {
                            (yyval.reg).regnum = (yyvsp[(1) - (1)].regnum); (yyval.reg).type = BWRITERSPR_CONST;
                        ;}
    break;

  case 149:

/* Line 1464 of yacc.c  */
#line 1193 "asmshader.y"
    {
                            (yyval.reg).regnum = (yyvsp[(1) - (1)].regnum); (yyval.reg).type = BWRITERSPR_CONSTINT;
                        ;}
    break;

  case 150:

/* Line 1464 of yacc.c  */
#line 1197 "asmshader.y"
    {
                            (yyval.reg).regnum = (yyvsp[(1) - (1)].regnum); (yyval.reg).type = BWRITERSPR_CONSTBOOL;
                        ;}
    break;

  case 151:

/* Line 1464 of yacc.c  */
#line 1201 "asmshader.y"
    {
                            (yyval.reg).regnum = (yyvsp[(1) - (1)].regnum); (yyval.reg).type = BWRITERSPR_TEXTURE;
                        ;}
    break;

  case 152:

/* Line 1464 of yacc.c  */
#line 1205 "asmshader.y"
    {
                            asmparser_message(&asm_ctx, "Line %u: Register oT%u is not a valid source register\n",
                                              asm_ctx.line_no, (yyvsp[(1) - (1)].regnum));
                            set_parse_status(&asm_ctx, PARSE_WARN);
                        ;}
    break;

  case 153:

/* Line 1464 of yacc.c  */
#line 1211 "asmshader.y"
    {
                            (yyval.reg).regnum = (yyvsp[(1) - (1)].regnum); (yyval.reg).type = BWRITERSPR_SAMPLER;
                        ;}
    break;

  case 154:

/* Line 1464 of yacc.c  */
#line 1215 "asmshader.y"
    {
                            asmparser_message(&asm_ctx, "Line %u: Register oPos is not a valid source register\n",
                                              asm_ctx.line_no);
                            set_parse_status(&asm_ctx, PARSE_WARN);
                        ;}
    break;

  case 155:

/* Line 1464 of yacc.c  */
#line 1221 "asmshader.y"
    {
                            asmparser_message(&asm_ctx, "Line %u: Register oFog is not a valid source register\n",
                                              asm_ctx.line_no);
                            set_parse_status(&asm_ctx, PARSE_WARN);
                        ;}
    break;

  case 156:

/* Line 1464 of yacc.c  */
#line 1227 "asmshader.y"
    {
                            asmparser_message(&asm_ctx, "Line %u: Register oD%u is not a valid source register\n",
                                              asm_ctx.line_no, (yyvsp[(1) - (1)].regnum));
                            set_parse_status(&asm_ctx, PARSE_WARN);
                        ;}
    break;

  case 157:

/* Line 1464 of yacc.c  */
#line 1233 "asmshader.y"
    {
                            asmparser_message(&asm_ctx, "Line %u: Register oC%u is not a valid source register\n",
                                              asm_ctx.line_no, (yyvsp[(1) - (1)].regnum));
                            set_parse_status(&asm_ctx, PARSE_WARN);
                        ;}
    break;

  case 158:

/* Line 1464 of yacc.c  */
#line 1239 "asmshader.y"
    {
                            asmparser_message(&asm_ctx, "Line %u: Register oDepth is not a valid source register\n",
                                              asm_ctx.line_no);
                            set_parse_status(&asm_ctx, PARSE_WARN);
                        ;}
    break;

  case 159:

/* Line 1464 of yacc.c  */
#line 1245 "asmshader.y"
    {
                            (yyval.reg).regnum = 0; (yyval.reg).type = BWRITERSPR_PREDICATE;
                        ;}
    break;

  case 160:

/* Line 1464 of yacc.c  */
#line 1249 "asmshader.y"
    {
                            (yyval.reg).regnum = 0; (yyval.reg).type = BWRITERSPR_MISCTYPE;
                        ;}
    break;

  case 161:

/* Line 1464 of yacc.c  */
#line 1253 "asmshader.y"
    {
                            (yyval.reg).regnum = 1; (yyval.reg).type = BWRITERSPR_MISCTYPE;
                        ;}
    break;

  case 162:

/* Line 1464 of yacc.c  */
#line 1257 "asmshader.y"
    {
                            (yyval.reg).regnum = 0; (yyval.reg).type = BWRITERSPR_ADDR;
                        ;}
    break;

  case 163:

/* Line 1464 of yacc.c  */
#line 1261 "asmshader.y"
    {
                            (yyval.reg).regnum = 0; (yyval.reg).type = BWRITERSPR_LOOP;
                        ;}
    break;

  case 164:

/* Line 1464 of yacc.c  */
#line 1265 "asmshader.y"
    {
                            (yyval.reg).regnum = (yyvsp[(1) - (1)].regnum); (yyval.reg).type = BWRITERSPR_LABEL;
                        ;}
    break;

  case 165:

/* Line 1464 of yacc.c  */
#line 1269 "asmshader.y"
    { (yyval.comptype) = BWRITER_COMPARISON_GT;       ;}
    break;

  case 166:

/* Line 1464 of yacc.c  */
#line 1270 "asmshader.y"
    { (yyval.comptype) = BWRITER_COMPARISON_LT;       ;}
    break;

  case 167:

/* Line 1464 of yacc.c  */
#line 1271 "asmshader.y"
    { (yyval.comptype) = BWRITER_COMPARISON_GE;       ;}
    break;

  case 168:

/* Line 1464 of yacc.c  */
#line 1272 "asmshader.y"
    { (yyval.comptype) = BWRITER_COMPARISON_LE;       ;}
    break;

  case 169:

/* Line 1464 of yacc.c  */
#line 1273 "asmshader.y"
    { (yyval.comptype) = BWRITER_COMPARISON_EQ;       ;}
    break;

  case 170:

/* Line 1464 of yacc.c  */
#line 1274 "asmshader.y"
    { (yyval.comptype) = BWRITER_COMPARISON_NE;       ;}
    break;

  case 171:

/* Line 1464 of yacc.c  */
#line 1277 "asmshader.y"
    {
                            TRACE("dcl_position%u\n", (yyvsp[(1) - (1)].regnum));
                            (yyval.declaration).regnum = (yyvsp[(1) - (1)].regnum);
                            (yyval.declaration).dclusage = BWRITERDECLUSAGE_POSITION;
                        ;}
    break;

  case 172:

/* Line 1464 of yacc.c  */
#line 1283 "asmshader.y"
    {
                            TRACE("dcl_blendweight%u\n", (yyvsp[(1) - (1)].regnum));
                            (yyval.declaration).regnum = (yyvsp[(1) - (1)].regnum);
                            (yyval.declaration).dclusage = BWRITERDECLUSAGE_BLENDWEIGHT;
                        ;}
    break;

  case 173:

/* Line 1464 of yacc.c  */
#line 1289 "asmshader.y"
    {
                            TRACE("dcl_blendindices%u\n", (yyvsp[(1) - (1)].regnum));
                            (yyval.declaration).regnum = (yyvsp[(1) - (1)].regnum);
                            (yyval.declaration).dclusage = BWRITERDECLUSAGE_BLENDINDICES;
                        ;}
    break;

  case 174:

/* Line 1464 of yacc.c  */
#line 1295 "asmshader.y"
    {
                            TRACE("dcl_normal%u\n", (yyvsp[(1) - (1)].regnum));
                            (yyval.declaration).regnum = (yyvsp[(1) - (1)].regnum);
                            (yyval.declaration).dclusage = BWRITERDECLUSAGE_NORMAL;
                        ;}
    break;

  case 175:

/* Line 1464 of yacc.c  */
#line 1301 "asmshader.y"
    {
                            TRACE("dcl_psize%u\n", (yyvsp[(1) - (1)].regnum));
                            (yyval.declaration).regnum = (yyvsp[(1) - (1)].regnum);
                            (yyval.declaration).dclusage = BWRITERDECLUSAGE_PSIZE;
                        ;}
    break;

  case 176:

/* Line 1464 of yacc.c  */
#line 1307 "asmshader.y"
    {
                            TRACE("dcl_texcoord%u\n", (yyvsp[(1) - (1)].regnum));
                            (yyval.declaration).regnum = (yyvsp[(1) - (1)].regnum);
                            (yyval.declaration).dclusage = BWRITERDECLUSAGE_TEXCOORD;
                        ;}
    break;

  case 177:

/* Line 1464 of yacc.c  */
#line 1313 "asmshader.y"
    {
                            TRACE("dcl_tangent%u\n", (yyvsp[(1) - (1)].regnum));
                            (yyval.declaration).regnum = (yyvsp[(1) - (1)].regnum);
                            (yyval.declaration).dclusage = BWRITERDECLUSAGE_TANGENT;
                        ;}
    break;

  case 178:

/* Line 1464 of yacc.c  */
#line 1319 "asmshader.y"
    {
                            TRACE("dcl_binormal%u\n", (yyvsp[(1) - (1)].regnum));
                            (yyval.declaration).regnum = (yyvsp[(1) - (1)].regnum);
                            (yyval.declaration).dclusage = BWRITERDECLUSAGE_BINORMAL;
                        ;}
    break;

  case 179:

/* Line 1464 of yacc.c  */
#line 1325 "asmshader.y"
    {
                            TRACE("dcl_tessfactor%u\n", (yyvsp[(1) - (1)].regnum));
                            (yyval.declaration).regnum = (yyvsp[(1) - (1)].regnum);
                            (yyval.declaration).dclusage = BWRITERDECLUSAGE_TESSFACTOR;
                        ;}
    break;

  case 180:

/* Line 1464 of yacc.c  */
#line 1331 "asmshader.y"
    {
                            TRACE("dcl_positiont%u\n", (yyvsp[(1) - (1)].regnum));
                            (yyval.declaration).regnum = (yyvsp[(1) - (1)].regnum);
                            (yyval.declaration).dclusage = BWRITERDECLUSAGE_POSITIONT;
                        ;}
    break;

  case 181:

/* Line 1464 of yacc.c  */
#line 1337 "asmshader.y"
    {
                            TRACE("dcl_color%u\n", (yyvsp[(1) - (1)].regnum));
                            (yyval.declaration).regnum = (yyvsp[(1) - (1)].regnum);
                            (yyval.declaration).dclusage = BWRITERDECLUSAGE_COLOR;
                        ;}
    break;

  case 182:

/* Line 1464 of yacc.c  */
#line 1343 "asmshader.y"
    {
                            TRACE("dcl_fog%u\n", (yyvsp[(1) - (1)].regnum));
                            (yyval.declaration).regnum = (yyvsp[(1) - (1)].regnum);
                            (yyval.declaration).dclusage = BWRITERDECLUSAGE_FOG;
                        ;}
    break;

  case 183:

/* Line 1464 of yacc.c  */
#line 1349 "asmshader.y"
    {
                            TRACE("dcl_depth%u\n", (yyvsp[(1) - (1)].regnum));
                            (yyval.declaration).regnum = (yyvsp[(1) - (1)].regnum);
                            (yyval.declaration).dclusage = BWRITERDECLUSAGE_DEPTH;
                        ;}
    break;

  case 184:

/* Line 1464 of yacc.c  */
#line 1355 "asmshader.y"
    {
                            TRACE("dcl_sample%u\n", (yyvsp[(1) - (1)].regnum));
                            (yyval.declaration).regnum = (yyvsp[(1) - (1)].regnum);
                            (yyval.declaration).dclusage = BWRITERDECLUSAGE_SAMPLE;
                        ;}
    break;

  case 185:

/* Line 1464 of yacc.c  */
#line 1362 "asmshader.y"
    {
                            (yyval.reg).regnum = (yyvsp[(1) - (1)].regnum); (yyval.reg).type = BWRITERSPR_INPUT;
                        ;}
    break;

  case 186:

/* Line 1464 of yacc.c  */
#line 1366 "asmshader.y"
    {
                            (yyval.reg).regnum = (yyvsp[(1) - (1)].regnum); (yyval.reg).type = BWRITERSPR_TEXTURE;
                        ;}
    break;

  case 187:

/* Line 1464 of yacc.c  */
#line 1371 "asmshader.y"
    {
                            (yyval.samplertype) = BWRITERSTT_1D;
                        ;}
    break;

  case 188:

/* Line 1464 of yacc.c  */
#line 1375 "asmshader.y"
    {
                            (yyval.samplertype) = BWRITERSTT_2D;
                        ;}
    break;

  case 189:

/* Line 1464 of yacc.c  */
#line 1379 "asmshader.y"
    {
                            (yyval.samplertype) = BWRITERSTT_CUBE;
                        ;}
    break;

  case 190:

/* Line 1464 of yacc.c  */
#line 1383 "asmshader.y"
    {
                            (yyval.samplertype) = BWRITERSTT_VOLUME;
                        ;}
    break;

  case 191:

/* Line 1464 of yacc.c  */
#line 1388 "asmshader.y"
    {
                            (yyval.reg).type = BWRITERSPR_PREDICATE;
                            (yyval.reg).regnum = 0;
                            (yyval.reg).rel_reg = NULL;
                            (yyval.reg).srcmod = BWRITERSPSM_NONE;
                            (yyval.reg).swizzle = (yyvsp[(3) - (4)].swizzle);
                        ;}
    break;

  case 192:

/* Line 1464 of yacc.c  */
#line 1396 "asmshader.y"
    {
                            (yyval.reg).type = BWRITERSPR_PREDICATE;
                            (yyval.reg).regnum = 0;
                            (yyval.reg).rel_reg = NULL;
                            (yyval.reg).srcmod = BWRITERSPSM_NOT;
                            (yyval.reg).swizzle = (yyvsp[(4) - (5)].swizzle);
                        ;}
    break;



/* Line 1464 of yacc.c  */
#line 4027 "asmshader.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1684 of yacc.c  */
#line 1404 "asmshader.y"


void asmshader_error (char const *s) {
    asmparser_message(&asm_ctx, "Line %u: Error \"%s\" from bison\n", asm_ctx.line_no, s);
    set_parse_status(&asm_ctx, PARSE_ERR);
}

/* Error reporting function */
void asmparser_message(struct asm_parser *ctx, const char *fmt, ...) {
    va_list args;
    char* newbuffer;
    int rc, newsize;

    if(ctx->messagecapacity == 0) {
        ctx->messages = asm_alloc(MESSAGEBUFFER_INITIAL_SIZE);
        if(ctx->messages == NULL) {
            ERR("Error allocating memory for parser messages\n");
            return;
        }
        ctx->messagecapacity = MESSAGEBUFFER_INITIAL_SIZE;
    }

    while(1) {
        va_start(args, fmt);
        rc = vsnprintf(ctx->messages + ctx->messagesize,
                       ctx->messagecapacity - ctx->messagesize, fmt, args);
        va_end(args);

        if (rc < 0 ||                                           /* C89 */
            rc >= ctx->messagecapacity - ctx->messagesize) {    /* C99 */
            /* Resize the buffer */
            newsize = ctx->messagecapacity * 2;
            newbuffer = asm_realloc(ctx->messages, newsize);
            if(newbuffer == NULL){
                ERR("Error reallocating memory for parser messages\n");
                return;
            }
            ctx->messages = newbuffer;
            ctx->messagecapacity = newsize;
        } else {
            ctx->messagesize += rc;
            return;
        }
    }
}

/* New status is the worst between current status and parameter value */
void set_parse_status(struct asm_parser *ctx, enum parse_status status) {
    if(status == PARSE_ERR) ctx->status = PARSE_ERR;
    else if(status == PARSE_WARN && ctx->status == PARSE_SUCCESS) ctx->status = PARSE_WARN;
}

struct bwriter_shader *parse_asm_shader(char **messages) {
    struct bwriter_shader *ret = NULL;

    asm_ctx.shader = NULL;
    asm_ctx.status = PARSE_SUCCESS;
    asm_ctx.messagesize = asm_ctx.messagecapacity = 0;
    asm_ctx.line_no = 1;

    asmshader_parse();

    if(asm_ctx.status != PARSE_ERR) ret = asm_ctx.shader;
    else if(asm_ctx.shader) SlDeleteShader(asm_ctx.shader);

    if(messages) {
        if(asm_ctx.messagesize) {
            /* Shrink the buffer to the used size */
            *messages = asm_realloc(asm_ctx.messages, asm_ctx.messagesize + 1);
            if(!*messages) {
                ERR("Out of memory, no messages reported\n");
                asm_free(asm_ctx.messages);
            }
        } else {
            *messages = NULL;
        }
    } else {
        if(asm_ctx.messagecapacity) asm_free(asm_ctx.messages);
    }

    return ret;
}

